#    Copyright 2018 D-Wave Systems Inc.

#    Licensed under the Apache License, Version 2.0 (the "License")
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at

#        http: // www.apache.org/licenses/LICENSE-2.0

#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.

embeddings = {'DW_2000Q_1':
              {'b0': [683, 555, 427],
               'b1': [416, 546, 418, 420],
               'b2': [675, 547],
               'and1,0': [431, 424],
               'and2,0': [299, 303, 295, 291],
               'and0,1': [428, 426, 682, 554],
               'and1,1': [678, 672, 544],
               'and2,1': [412, 413, 408, 536],
               'and0,2': [665, 671, 679],
               'and1,2': [557, 549, 541],
               'and2,2': [551, 559, 425, 430, 553, 422],
               'a0': [674, 685, 677],
               'a1': [552, 556, 548],
               'a2': [429, 421, 419],
               'carry1,0': [298, 296, 302, 294],
               'carry2,0': [290, 285, 293],
               'carry3,0': [281, 409, 414],
               'carry1,1': [550, 537, 542],
               'carry2,1': [411, 543, 539],
               'sum1,1': [289, 673, 545, 417],
               'sum2,1': [282, 540, 410, 538]},
              'SIMULATED_2000Q_CLOUD_TEST':
              {'a0': [431, 424, 175, 302, 168, 296],
               'a1': [148, 172, 156, 164],
               'a2': [417, 292, 289],
               'and0,1': [173, 165],
               'and0,2': [155, 167, 159],
               'and1,0': [171, 174],
               'and1,1': [152],
               'and1,2': [407, 415, 145, 273, 401],
               'and2,0': [303, 287, 295],
               'and2,1': [276, 284],
               'and2,2': [422, 419, 420],
               'b0': [169, 300, 297],
               'b1': [280, 162, 290, 286, 294],
               'b2': [160, 288, 416, 423],
               'carry1,0': [293, 291, 166, 163],
               'carry1,1': [400, 272, 144, 154, 149, 157],
               'carry2,0': [283, 285],
               'carry2,1': [275, 403, 406, 414],
               'carry3,0': [411, 412],
               'sum1,1': [281, 158, 153],
               'sum2,1': [282, 410]},
              'BAY4_2000Q_CLOUD_ALPHA':
              {'a0': [1762, 1634, 1638],
               'a1': [1897, 1513, 1769, 1641],
               'a2': [1899, 1643, 1771],
               'and0,1': [1764],
               'and0,2': [1505, 1516, 1633, 1508],
               'and1,0': [1772, 1770],
               'and1,1': [1645, 1637],
               'and1,2': [1523, 1651, 1518, 1526],
               'and2,0': [1765, 1768, 1773],
               'and2,1': [1639, 1647, 1655],
               'and2,2': [1649, 1644, 1652],
               'b0': [1767, 1775],
               'b1': [1635, 1903, 1895, 1891, 1763],
               'b2': [1646, 1514, 1642],
               'carry1,0': [1761, 1782, 1766, 1774],
               'carry1,1': [1382, 1376, 1390, 1384, 1640, 1512],
               'carry2,0': [1888, 1902, 1910, 1894, 1906, 1781, 1778],
               'carry2,1': [1517, 1525, 1520, 1648],
               'carry3,0': [1789, 1784, 1656, 1662, 1654],
               'sum1,1': [1504, 1760, 1632],
               'sum2,1': [1519, 1527, 1522, 1650]},
              'BAY4_2000Q_NEW_FEATURES':
               {'a0': [1762, 1634, 1638],
                'a1': [1897, 1513, 1769, 1641],
                'a2': [1899, 1643, 1771],
                'and0,1': [1764],
                'and0,2': [1505, 1516, 1633, 1508],
                'and1,0': [1772, 1770],
                'and1,1': [1645, 1637],
                'and1,2': [1523, 1651, 1518, 1526],
                'and2,0': [1765, 1768, 1773],
                'and2,1': [1639, 1647, 1655],
                'and2,2': [1649, 1644, 1652],
                'b0': [1767, 1775],
                'b1': [1635, 1903, 1895, 1891, 1763],
                'b2': [1646, 1514, 1642],
                'carry1,0': [1761, 1782, 1766, 1774],
                'carry1,1': [1382, 1376, 1390, 1384, 1640, 1512],
                'carry2,0': [1888, 1902, 1910, 1894, 1906, 1781, 1778],
                'carry2,1': [1517, 1525, 1520, 1648],
                'carry3,0': [1789, 1784, 1656, 1662, 1654],
                'sum1,1': [1504, 1760, 1632],
                'sum2,1': [1519, 1527, 1522, 1650]},
              'DW_2000Q_3':
              {'a0': [1762, 1634, 1638],
               'a1': [1897, 1513, 1769, 1641],
               'a2': [1899, 1643, 1771],
               'and0,1': [1764],
               'and0,2': [1505, 1516, 1633, 1508],
               'and1,0': [1772, 1770],
               'and1,1': [1645, 1637],
               'and1,2': [1523, 1651, 1518, 1526],
               'and2,0': [1765, 1768, 1773],
               'and2,1': [1639, 1647, 1655],
               'and2,2': [1649, 1644, 1652],
               'b0': [1767, 1775],
               'b1': [1635, 1903, 1895, 1891, 1763],
               'b2': [1646, 1514, 1642],
               'carry1,0': [1761, 1782, 1766, 1774],
               'carry1,1': [1382, 1376, 1390, 1384, 1640, 1512],
               'carry2,0': [1888, 1902, 1910, 1894, 1906, 1781, 1778],
               'carry2,1': [1517, 1525, 1520, 1648],
               'carry3,0': [1789, 1784, 1656, 1662, 1654],
               'sum1,1': [1504, 1760, 1632],
               'sum2,1': [1519, 1527, 1522, 1650]},
              'DW_2000Q_2':
              {'a0': [1871, 1879, 1887, 1895, 1888, 1760, 1632, 1864, 1638, 1630],
               'a1': [1742, 1750, 1758],
               'a2': [1629, 1617, 1621],
               'and0,1': [1625, 1631, 1624],
               'and0,2': [1736, 1608, 1614],
               'and1,0': [1757, 1752],
               'and1,1': [1737, 1609],
               'and1,2': [1747, 1494, 1491, 1619],
               'and2,0': [1745, 1740, 1748, 1756],
               'and2,1': [1618, 1490],
               'and2,2': [1637, 1634, 1506, 1509, 1501, 1493, 1488],
               'b0': [1626, 1754],
               'b1': [1612, 1755, 1620, 1628, 1627],
               'b2': [1744, 1622, 1616],
               'carry1,0': [1743, 1751, 1753, 1759],
               'carry1,1': [1615, 1483, 1623, 1611],
               'carry2,0': [1482, 1610, 1738],
               'carry2,1': [1484, 1492],
               'carry3,0': [1485, 1481],
               'sum1,1': [1741, 1739],
               'sum2,1': [1489, 1495, 1487]},
              'DW_2000Q_2_1':
              {'a0': [1871, 1879, 1887, 1895, 1888, 1760, 1632, 1864, 1638, 1630],
               'a1': [1742, 1750, 1758],
               'a2': [1629, 1617, 1621],
               'and0,1': [1625, 1631, 1624],
               'and0,2': [1736, 1608, 1614],
               'and1,0': [1757, 1752],
               'and1,1': [1737, 1609],
               'and1,2': [1747, 1494, 1491, 1619],
               'and2,0': [1745, 1740, 1748, 1756],
               'and2,1': [1618, 1490],
               'and2,2': [1637, 1634, 1506, 1509, 1501, 1493, 1488],
               'b0': [1626, 1754],
               'b1': [1612, 1755, 1620, 1628, 1627],
               'b2': [1744, 1622, 1616],
               'carry1,0': [1743, 1751, 1753, 1759],
               'carry1,1': [1615, 1483, 1623, 1611],
               'carry2,0': [1482, 1610, 1738],
               'carry2,1': [1484, 1492],
               'carry3,0': [1485, 1481],
               'sum1,1': [1741, 1739],
               'sum2,1': [1489, 1495, 1487]},
              'BAY1_2000Q_CLOUD_ALPHA':
              {'a0': [1260, 1268, 1266, 1394],
               'a1': [1515, 1387],
               'a2': [1257, 1385, 1513],
               'and0,1': [1269, 1264, 1392, 1397],
               'and0,2': [1244, 1241, 1374, 1369, 1497, 1503, 1252, 1511],
               'and1,0': [1256, 1384, 1389],
               'and1,1': [1390, 1380, 1376, 1382],
               'and1,2': [1646, 1642, 1518, 1514],
               'and2,0': [1254, 1262, 1263, 1258],
               'and2,1': [1393, 1521, 1508, 1524, 1516],
               'and2,2': [1641, 1520, 1653, 1648, 1645],
               'b0': [1399, 1386, 1391],
               'b1': [1396, 1388],
               'b2': [1522, 1527, 1519],
               'carry1,0': [1253, 1261],
               'carry1,1': [1638, 1634, 1632, 1504],
               'carry2,0': [1381, 1255, 1377, 1249],
               'carry2,1': [1633, 1639, 1647, 1512, 1640],
               'carry3,0': [1379, 1637, 1635, 1383, 1507, 1509, 1517],
               'sum1,1': [1506, 1250, 1378],
               'sum2,1': [1505, 1510]}}

